Emitter = gideros.class(Sprite)

function Emitter:init()
	self.PTCCount = 0
	self.TotalParticles = 500
	self.Radians = 3.1415 / 180
	self.AddPTC = 0
	self.First = particle.new(sprite)
	self.TempPart = self.First
	
	for b=1,self.TotalParticles,1 do
		local bitmap = Bitmap.new(Texture.new("particleTexture.png"))
		local bw = bitmap:getWidth()
		local bh = bitmap:getHeight()
		bitmap:setPosition(-bw/2,-bh/2)
		local sprite = Sprite.new()
		sprite:addChild(bitmap)
		sprite:setVisible(true)
		stage:addChild(sprite)
		self.TempPart = self.TempPart.Next
		self.TempPart.Next = particle.new(sprite);
		--print(self.TempPart)
	end
end

function Emitter:run()
	local TempPart = self.First
	for a = 1, self.TotalParticles do repeat
		TempPart = TempPart.Next
		if TempPart.Active == false then
			if self.AddPTC > 0 then
				local TempAng = math.random(359)
				TempPart.XPos = 100
				TempPart.YPos = 100
				TempPart.XThrust = math.cos(TempAng * self.Radians)
				TempPart.YThrust = math.sin(TempAng * self.Radians)
				TempPart.Thrust = 1 + math.random(10)
				TempPart.Active = true
				self.AddPTC = self.AddPTC - 1
				self.PTCCount = self.PTCCount + 1	
			else
				break
			end
		end
		
		if self.TempPart.Thrust <= 0.2 then
			self.TempPart.Active = false;
			self.PTCCount = self.PTCCount - 1;
		end
		
		if TempPart.Active == true then
			TempPart:run()
		end
	until true end
	self.PTCCount = self.PTCCount + 1
end

function Emitter:addParticles(self,num)
	self.AddPTC = num
	print("adding",num)
end

function Emitter:stop()

end

--[[
	TempPart = First;
	for (var a:uint = 0; a < TotalParticles; a++, TempPart = TempPart.Next) {
		if (TempPart.Active == false) {
			if (AddPTC > 0) {
				var TempAng:int = Math.round(Math.random()*359);
				TempPart.XPos = root.mouseX;
				TempPart.YPos = root.mouseY;
				TempPart.XThrust = Math.cos(TempAng * root.Radians);
				TempPart.YThrust = Math.sin(TempAng * root.Radians);
				TempPart.Thrust = 1 + Math.random()*10;
				TempPart.Active = true;
				AddPTC--;
				PTCCount += 1;
			} else {
				continue;
			}
		}
		TempPart.Main();
		BMD.setPixel32(TempPart.XPos, TempPart.YPos, 0xFF0088FF);
		if (TempPart.Thrust <= 0.2) {
			TempPart.Active = false;
			PTCCount -= 1;
		}
	}
	BMD.unlock();
	Count.text = PTCCount;

]]